Subject: Re: linux-next: manual merge of the scsi tree with the staging tree

From: "[email-masked]" <[email-masked]>
Date: Mon, 28 Aug 2017 20:47:13 +0200

On Mon, Aug 28, 2017 at 06:51:59PM +0100, James Bottomley wrote:
> On Mon, 2017-08-28 at 18:44 +0200, [email-masked] wrote:
> > On Mon, Aug 28, 2017 at 04:36:06PM +0000, Bart Van Assche wrote:
> > > 
> > > On Mon, 2017-08-28 at 18:05 +0200, [email-masked] wrote:
> > > > 
> > > > On Mon, Aug 28, 2017 at 03:41:28PM +0000, Bart Van Assche wrote:
> > > > > 
> > > > > * Most SCSI drivers exist under drivers/scsi, including the
> > > > > virtio-scsi and   xen-scsifront drivers. So why has the
> > > > > visorhba driver been added under unisys/visorhba?
> > > > 
> > > > That's because right now it's still a staging driver.  Also,
> > > > there are other scsi drivers in other portions of the kernel tree
> > > > (like the USB driver), so there's no hard rule that all scsi
> > > > drivers have to be under drivers/scsi/
> > > > 
> > > > <snip>
> > > > 
> > > > Please provide this review to them, on the properly mailing list,
> > > > I'm sure they would be glad to get it.
> > > 
> > > OK, I will do that. BTW, is there a written down version of the
> > > rules for adding a driver under drivers/staging available
> > > somewhere? 
> > 
> > The only 2 rules for adding a new drivers/staging driver is:
> > 	- has to compile
> > 	- correct license
> > and sometimes we let code in if the first one isn't true :)
> > 
> > > 
> > > As far as I can see the visorhba driver went in without the linux-
> > > scsi mailing list having been CC-ed. See also Benjamin Romer,
> > > [PATCH] staging: unisys: Add s-Par visorhba, linux-driver-devel
> > > mailing list, July 2015
> > > (https://urldefense.proofpoint.com/v2/url?u=https-3A__marc.info_-
> > > 3Fl-3Dlinux-2Ddriver-2Ddevel-26m-
> > > 3D143681271902628&d=DwIBAg&c=jf_iaSHvJObTbx-
> > > siA1ZOg&r=lxuMXTRCffN3cvb-
> > > aRKL97jBhWZUIH_7zc3AgXUz9Mw&m=muMI5n73yuzpaRBjZnIrYLfhcO8lIP0JZSjBG
> > > D1LC5I&s=76_tO8QEuhUmhJPijDkweBOfh6DLPRILWj9Rhphb8j0&e= ).
> > 
> > That's totally normal, why would the scsi developers care about a
> > staging driver in such a rough state.  Only when it looks "good
> > enough" would we ask for a scsi developer review to move it out of
> > staging.
> 
> I think I've said before, we'd really rather a SCSI driver went via the
> SCSI tree because most of what's wrong with it will be the mechanics of
> the driver and its interaction with the SCSI and block subsystems which
> simply don't get looked at in the staging tree.  The aesthetics and the
> formatting issues are mostly fixed by a quick trip through lindent or a
> brief education of the submitters on Linux style.

This driver has been in the tree for almost 2 years now, with no
problems in this area before.  It, and the infrastructure around it, has
needed hundreds, if not thousands, of patches and changes and reworks to
get it to the almost readable state it is in today.

It was anything but a "quick trip through lindent".

And we don't have code in the "real" part of the kernel depend on code
in drivers/staging/, as that would not work.

So let's just keep things as they are here, there's been no issues with
this for 2 years, and for times when there is, great, let me know and we
can work to fix things up.  You are always free to break staging drivers
with api changes, it's up to the owner of the staging driver to fix the
issues in that case.

thanks,

greg k-h